"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const isEqual_1 = __importDefault(require("lodash/isEqual"));
const cloneDeep_1 = __importDefault(require("lodash/cloneDeep"));
const simplifyQuery = (query, replaceAnd = true, replaceOr = true) => {
    let result = cloneDeep_1.default(query);
    if (result.$and) {
        const $and = [];
        result.$and.forEach(q => {
            q = simplifyQuery(q, true, true);
            if ($and.some(x => isEqual_1.default(x, q)))
                return;
            $and.push(q);
        });
        if (replaceAnd && $and.length === 1 && Object.keys(result).length === 1) {
            result = $and[0];
        }
        else {
            result.$and = $and;
        }
    }
    if (result.$or) {
        const $or = [];
        result.$or.forEach(q => {
            q = simplifyQuery(q, true, true);
            if ($or.some(x => isEqual_1.default(x, q)))
                return;
            $or.push(q);
        });
        if (replaceOr && $or.length === 1 && Object.keys(result).length === 1) {
            result = $or[0];
        }
        else {
            result.$or = $or;
        }
    }
    return result;
};
exports.default = simplifyQuery;
